/*
  Conversor universal de nmeros en distintas bases
  (C) Diciembre de 2.000 C con Clase
  Salvador Pozo Coronado
*/
#include <iostream.h>
#include <string.h>

int Convert(char *numero, int base);
bool VerificarNumero(char *numero, int base);
int ValorDigito(char d);

int main(int argc, char *argv[])
{
   /* Ejemplos */
   cout << "Conversin de '2131242' en octal a decimal: " << 
        Convert("2131242", 8) << endl;
   cout << "Conversin de '125' en octal a decimal: " << 
        Convert("125", 8) << endl;
   cout << "Conversin de '58785' en octal a decimal: " << 
        Convert("58785", 8) << endl;
   cout << "Conversin de '4F3D' en hexadecimal a decimal: " << 
        Convert("4F3D", 16) << endl;
   cout << "Conversin de '10110' en binario a decimal: " << 
        Convert("10110", 2) << endl;
   
   return 0;
}

int Convert(char *numero, int base)
{
   int Multiplicador = 1;
   int NDigitos, DigitoNo;
   int Valor = 0;
   
   if(!VerificarNumero(numero, base))
   {
      return -1;
   }
   
   NDigitos = strlen(numero);
   DigitoNo = NDigitos-1;

   while(DigitoNo >= 0)
   {
      Valor += ValorDigito(numero[DigitoNo])*Multiplicador;
      Multiplicador *= base;
      DigitoNo--;
   }
   return Valor;
}

bool VerificarNumero(char *numero, int base)
{
   int i = 0;
   int v;
   
   while(numero[i])
   {
      v = ValorDigito(numero[i]); 
      if(v < 0 || v >= base) return false;
      i++;
   }
   return true;
}

int ValorDigito(char d)
{
    if(d >= '0' && d <= '9') return d-'0';
    if(d >= 'a' && d <= 'f') return 10+d-'a';
    if(d >= 'A' && d <= 'F') return 10+d-'A';
    return -1; /* Caracter prohibido */
}
